/*---------------------------------------
Kodovi u racunarskim telekomunikacijama
            X domaci zadatak
"KB-HB kodovi za opticki prenos - 5B6B kod"
 prema resenju Ivana Milosavljevica 494/97
         (c) Copyright, maj 2004
-----------------------------------------*/

//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <iostream>
#include <fstream>
#include <dos>
#include <math>
#include "slucbr.h"
using namespace std;
    const int BR_BIT = 8000; //broj generisanih inf. bitova
    const int BR_BITA_PO_PROLAZU = 5;
    const int BR_PROLAZA = BR_BIT / BR_BITA_PO_PROLAZU;
    const int BR_KOD_BITA = BR_BIT*6/5;


int praviInfBit() {
    double slucajni;
    slucajni = urng ();
    if (slucajni < 0.8)
       return 0;
    else
       return 1;
}

void inicijalizacijaGrupePlusBitovi (unsigned long gpb[]) {
     gpb[0] = 110010;
     gpb[1] = 110011;
     gpb[2] = 110110;
     gpb[3] = 100011;
     gpb[4] = 110101;
     gpb[5] = 100101;
     gpb[6] = 100110;
     gpb[7] = 100111;
     gpb[8] = 101011;
     gpb[9] = 101001;
     gpb[10] = 101010;
     gpb[11] = 001011;
     gpb[12] = 101110;
     gpb[13] = 101101;
     gpb[14] = 101110;
     gpb[15] = 001110;
     gpb[16] = 110001;
     gpb[17] = 111001;
     gpb[18] = 111010;
     gpb[19] = 010011;
     gpb[20] = 110100;
     gpb[21] = 010101;
     gpb[22] = 010110;
     gpb[23] = 010111;
     gpb[24] = 111000;
     gpb[25] = 011001;
     gpb[26] = 011010;
     gpb[27] = 011011;
     gpb[28] = 011100;
     gpb[29] = 011101;
     gpb[30] = 011110;
     gpb[31] = 001101;
}

void inicijalizacijaGrupePlusIndikatori (char gpi[]) {
     gpi[0] = '+';
     gpi[1] = '-';
     gpi[2] = '-';
     gpi[3] = '+';
     gpi[4] = '-';
     gpi[5] = '+';
     gpi[6] = '+';
     gpi[7] = '-';
     gpi[8] = '-';
     gpi[9] = '+';
     gpi[10] = '+';
     gpi[11] = '+';
     gpi[12] = '+';
     gpi[13] = '-';
     gpi[14] = '-';
     gpi[15] = '+';
     gpi[16] = '+';
     gpi[17] = '-';
     gpi[18] = '-';
     gpi[19] = '+';
     gpi[20] = '+';
     gpi[21] = '+';
     gpi[22] = '+';
     gpi[23] = '-';
     gpi[24] = '+';
     gpi[25] = '+';
     gpi[26] = '+';
     gpi[27] = '-';
     gpi[28] = '+';
     gpi[29] = '-';
     gpi[30] = '-';
     gpi[31] = '+';
}

void inicijalizacijaGrupeMinusBitovi (unsigned long gpb[]) {
     gpb[0] = 110010;
     gpb[1] = 100001;
     gpb[2] = 100010;
     gpb[3] = 100011;
     gpb[4] = 100100;
     gpb[5] = 100101;
     gpb[6] = 100110;
     gpb[7] = 000111;
     gpb[8] = 101000;
     gpb[9] = 101001;
     gpb[10] = 101010;
     gpb[11] = 001011;
     gpb[12] = 101110;
     gpb[13] = 000101;
     gpb[14] = 000110;
     gpb[15] = 001110;
     gpb[16] = 110001;
     gpb[17] = 010001;
     gpb[18] = 010010;
     gpb[19] = 010011;
     gpb[20] = 110100;
     gpb[21] = 010101;
     gpb[22] = 010110;
     gpb[23] = 010110;
     gpb[24] = 011000;
     gpb[25] = 011001;
     gpb[26] = 011010;
     gpb[27] = 001010;
     gpb[28] = 011100;
     gpb[29] = 001001;
     gpb[30] = 001100;
     gpb[31] = 001101;
}

void inicijalizacijaGrupeMinusIndikatori (char gpi[]) {
     gpi[0] = '-';
     gpi[1] = '+';
     gpi[2] = '+';
     gpi[3] = '-';
     gpi[4] = '+';
     gpi[5] = '-';
     gpi[6] = '-';
     gpi[7] = '-';
     gpi[8] = '+';
     gpi[9] = '-';
     gpi[10] = '-';
     gpi[11] = '-';
     gpi[12] = '-';
     gpi[13] = '+';
     gpi[14] = '+';
     gpi[15] = '-';
     gpi[16] = '-';
     gpi[17] = '+';
     gpi[18] = '+';
     gpi[19] = '-';
     gpi[20] = '-';
     gpi[21] = '-';
     gpi[22] = '-';
     gpi[23] = '+';
     gpi[24] = '-';
     gpi[25] = '-';
     gpi[26] = '-';
     gpi[27] = '+';
     gpi[28] = '-';
     gpi[29] = '+';
     gpi[30] = '+';
     gpi[31] = '-';
}

float srednjaVrednostJedinica (int kodNiz[]) {
    int ukBrojJedinica = 0;
    float srVrednost;
    for (int i = 0; i < BR_KOD_BITA; i++) {
        if (kodNiz[i] == 1) ukBrojJedinica++;
    }
    srVrednost =  (float)ukBrojJedinica / BR_KOD_BITA;
    return srVrednost;
}

int maxBrojJedinica (int kodNiz[]) {
    int tekBrUzastopnihJed = 0;
    int maxBr = 1;
    for (int i = 0; i < BR_KOD_BITA; i++) {
        if (kodNiz[i] == 1) {
           tekBrUzastopnihJed++;
           if (maxBr < tekBrUzastopnihJed)
              maxBr = tekBrUzastopnihJed;
        }
        else
            tekBrUzastopnihJed = 0;
    }
    return maxBr;
}

int maxBrojNula (int kodNiz[]) {
    int tekBrUzastopnihNula = 0;
    int maxBr = 1;
    for (int i = 0; i< BR_KOD_BITA; i++) {
        if (kodNiz[i] == 0) {
           tekBrUzastopnihNula++;
           if (maxBr < tekBrUzastopnihNula)
              maxBr = tekBrUzastopnihNula;
        }
        else
            tekBrUzastopnihNula = 0;
    }
    return maxBr;
}

float prosecanBrojJedinica (int kodNiz[]) {
      int prethodniBit = 0;
      int brSekvenci = 0;
      float prosBrJed;
      int ukBrojJedinica = 0;
      for (int i = 0; i < BR_KOD_BITA; i++) {
          if (kodNiz[i] == 1) ukBrojJedinica++;
      }
      for (int i = 0; i < BR_KOD_BITA; i++) {
          if (prethodniBit == 0 && kodNiz[i] == 1) {
             brSekvenci++;
             prethodniBit = 1;
          }
          else
              if (kodNiz[i] == 0)
                 prethodniBit = 0;
      }
      prosBrJed = (float)ukBrojJedinica / brSekvenci;
      return prosBrJed;
}

float prosecanBrojNula (int kodNiz[]) {
      int prethodniBit = 1;
      int brSekvenci = 0;
      float prosBrNula;
      int ukBrojNula = 0;
      for (int i = 0; i < BR_KOD_BITA; i++) {
          if (kodNiz[i] == 0) ukBrojNula++;
      }
      for (int i = 0; i < BR_KOD_BITA; i++) {
          if (prethodniBit == 1 && kodNiz[i] == 0) {
             brSekvenci++;
             prethodniBit = 0;
          }
          else
              if (kodNiz[i] == 1)
                 prethodniBit = 1;
      }
      prosBrNula = (float)ukBrojNula / brSekvenci;
      return prosBrNula;
}


int main(int argc, char* argv[])
{
    int kodovaniNiz [BR_KOD_BITA]; //5b6b kodovan informacioni niz
    unsigned long grupaPlusBitovi [32]; //predefinisani kodovani bitovi
    unsigned long grupaMinusBitovi [32];
    char grupaPlusIndikator [32]; //indikatori sledece grupe
    char grupaMinusIndikator [32];

    //sad idu promenljive koje nam trebaju za racunanje...
    char indikatorSledeceGrupe = '+';
    int maxBrojUzastopnihJedinica = 1;
    int maxBrojUzastopnihNula = 1;
    float prosecanBrojUzastopnihJedinica;
    float prosecanBrojUzastopnihNula;
    float srVrednostJedinica;

    //pa da pocnemo...
    set_urng (188);
    inicijalizacijaGrupePlusBitovi (grupaPlusBitovi);
    inicijalizacijaGrupePlusIndikatori (grupaPlusIndikator);
    inicijalizacijaGrupeMinusBitovi (grupaMinusBitovi);
    inicijalizacijaGrupeMinusIndikatori (grupaMinusIndikator);
    for (int j = 0; j<BR_PROLAZA; j++) {
        int sumaInfSekvence = 0;
        int tmpInfBit[5];
        for (int i = 0; i<BR_BITA_PO_PROLAZU; i++) {
            int infBit = praviInfBit();
            tmpInfBit[i] = infBit;
            sumaInfSekvence += infBit * pow(2, 4-i);
        }
        if (indikatorSledeceGrupe == '+') {
           unsigned long bufferGrupe = grupaPlusBitovi [sumaInfSekvence];
           kodovaniNiz [6*j] = bufferGrupe / 100000;
           kodovaniNiz [6*j+1] = (bufferGrupe / 10000) % 10;
           kodovaniNiz [6*j+2] = (bufferGrupe / 1000) % 10;
           kodovaniNiz [6*j+3] = (bufferGrupe / 100) % 10;
           kodovaniNiz [6*j+4] = (bufferGrupe / 10) % 10;
           kodovaniNiz [6*j+5] = bufferGrupe % 10;
           indikatorSledeceGrupe = grupaPlusIndikator [sumaInfSekvence];
        }
        else {
           unsigned long bufferGrupe = grupaMinusBitovi [sumaInfSekvence];
           kodovaniNiz [6*j] = bufferGrupe / 100000;
           kodovaniNiz [6*j+1] = (bufferGrupe / 10000) % 10;
           kodovaniNiz [6*j+2] = (bufferGrupe / 1000) % 10;
           kodovaniNiz [6*j+3] = (bufferGrupe / 100) % 10;
           kodovaniNiz [6*j+4] = (bufferGrupe / 10) % 10;
           kodovaniNiz [6*j+5] = bufferGrupe % 10;
           indikatorSledeceGrupe = grupaMinusIndikator [sumaInfSekvence];
        } //end of else
    } //end of for BR_PROLAZA
    srVrednostJedinica = srednjaVrednostJedinica (kodovaniNiz);
    maxBrojUzastopnihJedinica = maxBrojJedinica (kodovaniNiz);
    maxBrojUzastopnihNula = maxBrojNula (kodovaniNiz);
    prosecanBrojUzastopnihJedinica = prosecanBrojJedinica (kodovaniNiz);
    prosecanBrojUzastopnihNula = prosecanBrojNula (kodovaniNiz);
    cout << "Srednja vrednost (verovatnoca pojavljivanja jedinice): " << srVrednostJedinica << endl;
    cout << "Max. broj uzastopnih jedinica: " << maxBrojUzastopnihJedinica << endl;
    cout << "Max. broj uzastopnih nula: " << maxBrojUzastopnihNula << endl;
    cout << "Prosecan broj uzastopnih jedinica : " << prosecanBrojUzastopnihJedinica << endl;
    cout << "Prosecan broj uzastopnih nula : " << prosecanBrojUzastopnihNula << endl;
    _sleep (8);
    return 0;
}
//---------------------------------------------------------------------------
